##### 二、直接插入排序

基本思想：每次将一个待排序的记录，按其关键字大小插入到前面已经排好序的子序列中的适当位置，直到全部记录插入完成为止。
设数组为a[0…n-1]。<br>
1.初始时，a[0]自成1个有序区，无序区为a[1..n-1]。令i=1<br>
2.将a[i]并入当前的有序区a[0…i-1]中形成a[0…i]的有序区间。<br>
3.i++并重复第二步直到i==n-1。排序完成。<br>
> 时间复杂度：O(N^2)
<html>
<img name="insert" src="https://github.com/plclovelife/AlgorithmLearning/blob/master/Image/poker.png?raw=true">
</html>

> 代码实现（C++）

```
void InsertSort1(int a[],int n)
{//直接插入排序
    int i, j, k;
    for ( i = 1; i < n; i++)//第一个元素天然有序，从a[1]开始插入
    {
        for (j = i-1; j>=0; j--)//a[0]至a[i-1]为有序数列
        {	
	    if (a[j] <= a[i])//找到合适位置跳出循环，准备插入
	    {
		break;
	    }
    	}
	    if (j != i - 1)//若找到的位置不是有序组最后一个
	    {//若j=i-1,则a[0]-a[i]已有序，无需排序
		int temp = a[i];
		for (k = i - 1; k > j; k--)
		{//从a[i-1]开始向前到a[j+1]每项后移一位
		 //a[i-1]→a[i];…;a[j+1]→a[j+2]
		    a[k + 1] = a[k];
		}
		a[k + 1] = temp;//a[i]插入合适位置a[j+1]
	    }
	}
}
```

###### 直接插与冒泡的差别（由小到大排序）：
冒泡排序目的是将最大值放到末尾位置，是**定好位置找数据**；直接插入排序目的是将现有的值按大小插入到合适位置，是**拿着数据找位置**
> 长度200000的随机数组排序结果：
<html>
<img name="insert" src="https://github.com/plclovelife/AlgorithmLearning/blob/master/Image/insertsort.png?raw=true">
</html>
