##### 三、希尔排序

> 希尔排序的实质就是分组插入排序，该方法又称缩小增量排序，因DL．Shell于1959年提出而得名。

###### 基本思想：
先将整个待排元素序列分割成若干个子序列（由相隔某个“增量”的元素组成的）分别进行直接插入排序，然后依次缩减增量再进行排序，待整个序列中的元素基本有序（增量足够小）时，再对全体元素进行一次直接插入排序。因为直接插入排序在元素基本有序的情况下（接近最好情况），效率是很高的，因此希尔排序在时间效率上比前两种方法有较大提高。
> 时间复杂度：O(N^1.3)（经验？）

> 代码实现（C++）

```
void ShellSort1(int a[],int n)
{//希尔排序
	int i, j, gap;
	for (gap = n / 3; gap > 0; gap /= 3)
	{//设置步长
	    for (i = 0; i < gap; i++)//直接插入排序
	    {
	        for (j = i + gap; j < n; j+=gap)
	        {//a[i]、a[i+gap]、a[i+2gap]...分为一组进行直接插入排序
	            if (a[j-gap] > a[j])
	            {//a[j]看作要插入有序组的新数据
	             //若a[j]>a[j-1]则为一个新的有序数组，无需排序
	                int temp = a[j];
	                int k = j - gap;
		        while (k >= 0 && a[k] > temp)
		        {//所有大于要插入元素的数据后移一位
		         //找到要插入的位置
		            a[k + gap] = a[k];
        		    k -= gap;
    		    }
		        a[k + gap] = temp;//插入合适位置
		}
                }
	    }
	}
}

void shellsort2(int a[], int n)  
{//优化的希尔排序
    int j, gap;       
    for (gap = n / 2; gap > 0; gap /= 2)  
    {   
        for (j = gap; j < n; j++)//从数组第gap个元素开始  
        {        
	    if (a[j] < a[j - gap])//每个元素与自己组内的数据进行直接插入排序  
            {  
                int temp = a[j];  
                int k = j - gap;  
                while (k >= 0 && a[k] > temp)  
                {  
                    a[k + gap] = a[k];  
                    k -= gap;  
                }  
                a[k + gap] = temp;  
            }  
        }
    }
}
```


```
//生成随机数组
const int N = 200000；
int a[N];
int m；
srand((unsigned)time(NULL));//设置rand()随机种子与时间关联
for (m = 0; m < N; m++)
{
    a[m] = rand();
}
```

>长度200000随机数组排序结果：


<html>
<img name=shellsort src="https://github.com/plclovelife/studyalgorithm/blob/master/Image/shellsort.png?raw=true" width=200>
</html>

