##### 四、直接选择排序

直接选择排序和直接插入排序类似，都将数据分为有序区和无序区，所不同的是直接插入排序是将无序区的第一个元素直接插入到有序区以形成一个更大的有序区，而**直接选择排序**是从无序区选一个最小的元素直接放到有序区的最后。

###### 算法思想：

设数组为a[0…n-1]。

1.初始时，数组全为无序区为a[0..n-1]。令i=0<br>
2.在无序区a[i…n-1]中选取一个最小的元素，将其与a[i]交换。交换之后a[0…i]就形成了一个有序区。<br>
3.i++并重复第二步直到i==n-1。排序完成。
> 时间复杂度：O(N^2)

> 代码实现


```
void SelectSort(int a[], int n)
{//直接选择排序
	int i, j, min;
	for (i = 0; i < n; i++)
	{
		min = i;//最小元素的位置
		for (j = i + 1; j < n; j++)
		{//查找最小元素
			if (a[j] < a[min])
			{
				min = j;
			}
		}
		Swap(a[i], a[min]);//最小元素换到有序区后
	}
}
```
> 长度200000随机数组排序结果：
<html>
<img name=selectsort src="https://github.com/plclovelife/AlgorithmLearning/blob/master/Image/selectsort.png?raw=true">
</html>


