##### 五、归并排序

归并排序是建立在归并操作上的一种有效的排序算法。该算法是采用分治法（Divide and Conquer）的一个非常典型的应用。<br>
归并排序，其的基本思路就是将数组分成二组A，B，如果这二组组内的数据都是有序的，那么就可以很方便的将这二组数据进行排序。<br>
可以将A，B组各自再分成二组。依次类推，当分出来的小组只有一个数据时，可以认为这个小组组内已经达到了有序，然后再合并相邻的二个小组就可以了。这样通过先递归的分解数列，再合并数列就完成了**归并排序**。

> 时间复杂度：O(NlogN)

<html>
<img name=mergesort src="https://github.com/plclovelife/AlgorithmLearning/blob/master/Image/mergesort.png?raw=true" width=440>
</html>



> 代码实现：

```
void MergeArray(int a[], int first,int mid, int last,int temp[])
{//合并两个有序数组，效率O(n)
	int i, j, k;
	i = first;
	k = 0;
	int m = mid;
	j = mid + 1;
	while (i<=m && j<=last)
	{//比较二个数列的第一个数，谁小就先取谁，取了后就在对应数列中删除这个数。然后再进行比较
		if (a[i] <= a[j])
		{
			temp[k++] = a[i++];
		}
		else
		{
			temp[k++] = a[j++];
		}
	}
	//如果有数列为空，那直接将另一个数列的数据依次取出即可
	while (i<=m)
	{
		temp[k++] = a[i++];
	}
	while (j<=last)
	{
		temp[k++] = a[j++];
	}
	for (i = 0; i < k; i++)
	{
		a[first+i] = temp[i];//排序后数组写入a[]
	}
}
void mergesort(int a[], int first, int last, int temp[])
{//归并排序，将数组a[]分为a[0—mid]和a[mid+1—last]两个数组
	if (first < last)
	{
		int mid = (first + last) / 2;
		mergesort(a, first, mid, temp);    //左边有序  
		mergesort(a, mid + 1, last, temp); //右边有序  
		MergeArray(a, first, mid, last, temp); //再将二个有序数列合并  
	}
}
bool MergeSort(int a[], int n)
{
	int *p = new int[n];//创建临时数组用于temp[]
	if (p == NULL)
		return false;
	mergesort(a, 0, n - 1, p);//调用归并函数
	delete[] p;//释放空间
	return true;
}
```

###### 长度200000的随机数组排序结果：


<html>
<img name=msresult src="https://github.com/plclovelife/AlgorithmLearning/blob/master/Image/msresult.png?raw=true" width=250>
</html>

