##### 六、快速排序

> 基本思想：（**分治**）<br>
1. 从数组中选择一个值为key值；<br>
2. 把所有比key小的放在key左边，比key大的放在key右边；<br>
3. 然后分别对左右两边的数组重复1-2，直到各区间数组长度为一。

> 平均时间复杂度：**O(NlogN)**

> 代码实现:

```
void QuickSort(int a[],int l,int r)
{
    if (l >= r)
    {
	    return;
	}
	int key = a[l];//选择第一个数为key，也可以选择其他位置的数据作为key
	int i = l, j = r;
	while (i < j)
	{
		while 
		(i<j && a[j]>=key)//从右到左找第一个小于key的数
		{
			j--;
		}
		if (i < j)
		{
			a[i] = a[j];
			i++;
		}
		while (i<j && a[i]<key)//从左到右找第一个大于key的数
		{
			i++;
		}
		if (i < j)
		{
			a[j] = a[i];
			j--;
		}
	}
	a[i] = key;
	QuickSort(a, l, i - 1);
	QuickSort(a, i + 1, r);

}
```


###### 长度200000的随机数组排序结果：
<html>
<img name=msresult src="https://github.com/plclovelife/AlgorithmLearning/blob/master/Image/quicksort.png?raw=true" width=250>
</html>